
#include "main.h"

#define UART_TX	D,1
#define UART_RX	D,2
#define UART_DELAY	52 // 1/9600 = 104uS : 1/19200 = 52uS


void uart_putc(char c)
{
  uchar i;
  uchar temp;
  
  // start 
  set_output(UART_TX);
  _delay_us(UART_DELAY);
  clr_output(UART_TX);

  for(i=0;i<8;i++)
  {
    temp = c&1;
    if (temp==0)
      set_output(UART_TX);
    else
      clr_output(UART_TX);
    _delay_us(UART_DELAY);
    
     c = c >>1;
  }

  // stop
  set_output(UART_TX);
  _delay_us(UART_DELAY);
  clr_output(UART_TX);

  _delay_us(UART_DELAY);
}


void uart_puts (char *s)
{
  while (*s)
    uart_putc(*s++);
}


uchar uart_getc()
{
  uchar i;
  uchar ib = 0;
  uchar currentChar=0;

  while (ib != 1) 
    ib = get_input(UART_RX);

  _delay_us(UART_DELAY/2); // middle of the start bit 
  for(i=0;i<8;i++)
    {
      _delay_us(UART_DELAY);
      ib = get_input(UART_RX);

      if (ib ==0)
	currentChar |= 1<<i; // this is a 1
    }
  return currentChar;
}



int main( void )
{
  uchar c = 0;

  drive(UART_TX);
  tristate(UART_RX);
  sei();

  uart_puts("[M8] Boot !\r\n");  

  while (1) 
  {
    c = uart_getc();
    uart_putc(c);
  }


  return 0;
}
